package sun.io;

import java.io.UnsupportedEncodingException;

public abstract class ByteToCharConverter {
   protected boolean subMode = true;
   protected char[] subChars = new char[]{'�'};
   protected int charOff;
   protected int byteOff;
   protected int badInputLength;
   private static String pkgString = System.getProperty("file.encoding.pkg");
   private static Class defClassCache;

   private static Class getConverterClass(String var0) throws ClassNotFoundException {
      Object var1 = null;
      String var2 = CharacterEncoding.aliasName(var0);
      if (var2 == null) {
         var2 = var0;
      }

      return Class.forName(pkgString + ".ByteToChar" + var2);
   }

   public static ByteToCharConverter getDefault() {
      if (defClassCache == null) {
         return new ByteToCharDefault();
      } else {
         try {
            return (ByteToCharConverter)defClassCache.newInstance();
         } catch (InstantiationException var0) {
            return new ByteToCharDefault();
         } catch (IllegalAccessException var1) {
            return new ByteToCharDefault();
         }
      }
   }

   public static ByteToCharConverter getConverter(String var0) throws UnsupportedEncodingException {
      ByteToCharConverter var2 = null;

      Class var1;
      try {
         var1 = getConverterClass(var0);
      } catch (ClassNotFoundException var5) {
         throw new UnsupportedEncodingException();
      }

      try {
         var2 = (ByteToCharConverter)var1.newInstance();
         return var2;
      } catch (InstantiationException var3) {
         throw new UnsupportedEncodingException();
      } catch (IllegalAccessException var4) {
         throw new UnsupportedEncodingException();
      }
   }

   public abstract String getCharacterEncoding();

   public abstract int convert(byte[] var1, int var2, int var3, char[] var4, int var5, int var6) throws MalformedInputException, UnknownCharacterException, ConversionBufferFullException;

   public char[] convertAll(byte[] var1) throws MalformedInputException {
      this.reset();
      boolean var2 = this.subMode;
      this.subMode = true;
      char[] var3 = new char[this.getMaxCharsPerByte() * var1.length];

      char[] var4;
      try {
         int var7 = this.convert(var1, 0, var1.length, var3, 0, var3.length);
         var7 += this.flush(var3, this.nextByteIndex(), var3.length);
         char[] var8 = new char[var7];
         System.arraycopy(var3, 0, var8, 0, var7);
         var4 = var8;
      } catch (ConversionBufferFullException var12) {
         throw new InternalError("this.getMaxCharsBerByte returned bad value");
      } catch (UnknownCharacterException var13) {
         throw new InternalError();
      } finally {
         this.subMode = var2;
      }

      return var4;
   }

   public abstract int flush(char[] var1, int var2, int var3) throws MalformedInputException, ConversionBufferFullException;

   public abstract void reset();

   public int getMaxCharsPerByte() {
      return 1;
   }

   public int getBadInputLength() {
      return this.badInputLength;
   }

   public int nextCharIndex() {
      return this.charOff;
   }

   public int nextByteIndex() {
      return this.byteOff;
   }

   public void setSubstitutionMode(boolean var1) {
      this.subMode = var1;
   }

   public void setSubstitutionChars(char[] var1) throws IllegalArgumentException {
      if (var1.length > this.getMaxCharsPerByte()) {
         throw new IllegalArgumentException();
      } else {
         this.subChars = new char[var1.length];
         System.arraycopy(var1, 0, this.subChars, 0, var1.length);
      }
   }

   public String toString() {
      return "ByteToCharConverter: " + this.getCharacterEncoding();
   }

   static {
      try {
         String var0 = System.getProperty("file.encoding", "8859_1");
         defClassCache = getConverterClass(var0);
      } catch (ClassNotFoundException var1) {
         defClassCache = null;
      }
   }
}
